!Drawing beta
!INPUT:P,N,K,KH,Z,X,ICORR,gamma1,c1,mz,vz,varx,betap
!OUTPUT:BET


	SUBROUTINE GHBETA1(P,N,K,KH,Z,X,ICORR,gamma1,c1,BET,mz,vz,varx,betap)

	USE NUMERICAL_LIBRARIES

	IMPLICIT NONE

!Input+some constants
	INTEGER ::  P, K, T, I, J, LDRSIG, IRANK,N,KH,betap
	DOUBLE PRECISION ::  gamma1, c1, ICORR(N,N)
	DOUBLE PRECISION ::  Z(P), X(N,KH), XTX(K,K)
	DOUBLE PRECISION :: mz,vz,varx(KH)

!Ouput+intermediate calculations
	DOUBLE PRECISION :: HH(K,K),IHH(K,K), HSIG(K,K),IHSIG(K,K),IHHX(K,P)
	DOUBLE PRECISION :: ZEL(P),BET1(K),BET(K),NORMA(K),ICORRX(P,K),ICORRZ(P)

	DOUBLE PRECISION :: cvz

	IF(betap.eq.0) THEN 
		cvz=c1
	ELSE
		cvz=c1*vz
	END IF


!X'*ICORR*X
!ICORR*X=ICORRX

	CALL DMRRRR(P,P,ICORR,N,P,K,X,N,P,K,ICORRX,P) 

!X'*ICORR*X=XTX

	CALL DMXTYF(P,K,X,N,P,K,ICORRX,P,K,K,XTX,K) 
	
!1.1.- HH=X'*ICORR*X/sigma^2+(1/a)*I_k or HH=X'*ICORR*X/sigma^2+(1/cvz)*sigma_beta 


	HH(1,1)=XTX(1,1)*gamma1+1/cvz
	DO I=2,K
		HH(I,I)=XTX(I,I)*gamma1+varx(I)/cvz
		DO J=1,I-1
			HH(I,J)=XTX(I,J)*gamma1
			HH(J,I)=XTX(J,I)*gamma1
		END DO
	END DO

!1.2.- IHH=HH^{-1}

!Cholesky decomposition of HH


	IRANK=K
	LDRSIG=K

	CALL DCHFAC(K, HH, K, 1.00D-100, IRANK, HSIG, LDRSIG)
		
!Inversion of RSIG=IRSIG

	CALL DLINRT(K, HSIG, K, 2,IHSIG, K) !L^{-1} 

	!IHH=HH^{-1} = L^{-1}*L^{-t}  L is the upper triangular.

	CALL DMXYTF(K,K,IHSIG,K,K,K,IHSIG,K,K,K,IHH,K)


!1.3.- IHHX=HH^{-1}*X'

	CALL DMXYTF(K,K,IHH,K,P,K,X,N,K,P,IHHX,K)

!1.4.- ICORRZ=ICORR*Z
	
	CALL DMURRV(P,P,ICORR,N,P,Z,1,P,ICORRZ)

!1.5.- bet1=IHHX*ICORRZ

	CALL DMURRV(K,P,IHHX,K,P,ICORRZ,1,K,bet1)

	IF(BETAP.EQ.1) THEN
	!1.5.1.- bet1=BET1+IHH*(1/(c1*varz))*sigma_beta*mz
		DO I=1,K
			bet1(I)=bet1(I)*gamma1+IHH(I,1)*mz/cvz
		END DO
	ELSE
		DO I=1,K
			bet1(I)=bet1(I)*gamma1
		END DO
	END IF

!1.6.-	Normal(bet1, HH^{-1})

	CALL DRNMVN(1,K,IHSIG,K,NORMA,1)

	DO J=1,K
		BET(J)=NORMA(J)+BET1(J)
	END DO


	END SUBROUTINE GHBETA1