!Sampling omega2
!INPUT:P,N,DIST,thet2,phi,RES,gamma1,R,burnin,omegachange,c4,c5,clam45,omega2,CORR,ICORR,deter
!OUTPUT:omegachange,omega2



	SUBROUTINE Gomegdraw(P,N,DIST,thet2,phi,RES,gamma1,R,burnin,omegachange,c4,c5,clam45,omega2,CORR,ICORR,deter)

	USE NUMERICAL_LIBRARIES

	IMPLICIT NONE

	INTEGER :: I, J, P, T,R,burnin,N
	DOUBLE PRECISION :: CORR(N,N),ICORR(N,N),deter, RES(P), gamma1,omega2
	DOUBLE PRECISION :: u1, U, omegacan, a, accep, omegachange, kappa
	DOUBLE PRECISION :: dIF, dIFlog,dIFinv,TIT,dIFdet,DIST(N,N)
	DOUBLE PRECISION :: clomega2,y,c4,c5,clam45,b, phi,thet2
	DOUBLE PRECISION :: CORR1(N,N),ICORR1(N,N), DIFICORR(P,P),deter1

	kappa=5.00D-1 

    !Candidate from Normal(ln(omega2),kappa)

 	CALL DRNNOR(1,clomega2) !N(0,1)
	
	y=dlog(omega2)

	clomega2=clomega2*kappa+y
	
	omegacan=dexp(clomega2)


	CALL GCORRELATION(P,N,DIST,thet2,phi,omegacan,CORR1,ICORR1,deter1)

	IF(deter1.lt.1.00D-250) THEN
		deter1=1.00D-250
		PRINT *, 'The determinant is truncated in omega2'
	END IF

	dIFdet=dlog(deter1)-dlog(deter)
	DO I=1,P
		DO J=1,P
			DIFICORR(I,J)=ICORR1(I,J)-ICORR(I,J)
		END DO
	END DO

	TIT=DBLINF(P,P,DIFICORR,P,RES,RES)

	dIFlog=dlog(omegacan)-dlog(omega2)

	dIFinv=0.5D0*C4*(1/omegacan-1/omega2)

	dIF=omegacan-omega2

	b=1-clam45+0.5d0*c5**2
	
	a=-0.5*dIFdet-0.5d0*gamma1*TIT-b*dIF-dIFinv+dIFlog

	IF(a.lt.0.0d0) THEN
 		accep=dexp(a)
	ELSE
		accep=1.0d0
	END IF


	CALL DRNUN(1,U) !UnIForm[0,1]

	IF(U.LT.accep)	THEN 
		omega2=omegacan

		deter=deter1

		DO I=1,P
			DO J=1,P
				CORR(I,J)=CORR1(I,J)
				ICORR(I,J)=ICORR1(I,J)
			END DO
		END DO


		IF(R.GT.burnin)  omegachange=omegachange+1

	END IF


END SUBROUTINE Gomegdraw