!Sampling theta_1, the range
!INPUT:P,N,RES,thet2,DIST,CORR,ICORR,deter,c8,mdis,phi,thet1,R,burnin,thet1change,omega2,gamma1
!OUTPUT:phi,thet1,thet1change



	SUBROUTINE GTHETA1(P,N,RES,thet2,DIST,CORR,ICORR,deter,c8,mdis,phi,thet1,R,burnin,thet1change,omega2,gamma1)

	USE NUMERICAL_LIBRARIES

	IMPLICIT NONE

	INTEGER :: I, J, P, T,R,burnin,N
	INTEGER:: LDRSIG, IRANK	
	DOUBLE PRECISION :: DIST(N,N), CORR(N,N), ICORR(N,N), deter,omega2,gamma1
	DOUBLE PRECISION :: CORR1(N,N), ICORR1(N,N), deter1,RES(P)
	DOUBLE PRECISION :: phi,thet2,thet1
	DOUBLE PRECISION :: u1, U, canthet1, a, c8, accep,thet1change, kappa
	DOUBLE PRECISION :: dIFdet, DIFICORR(P,P), dif, diflog, TIT
	DOUBLE PRECISION :: clthet1,y,canphi,mdis

	kappa=3.00D-1 

    !Candidate from Normal(ln(thet1),kappa)

 	CALL DRNNOR(1,clthet1) !N(0,1)
	
	y=dlog(thet1)

	clthet1=clthet1*kappa+y
	
	canthet1=dexp(clthet1)

	canphi=1/canthet1

	CALL GCORRELATION(P,N,DIST,thet2,canphi,omega2,CORR1,ICORR1,deter1)

	IF(deter1.lt.1.00D-250) THEN
		deter1=1.00D-250
		PRINT *, 'The determinant is truncated in theta1'
	END IF
	
	difdet=dlog(deter1)-dlog(deter)
	DO I=1,P
		DO J=1,P
			DIFICORR(I,J)=ICORR1(I,J)-ICORR(I,J)
		END DO
	END DO

	TIT=DBLINF(P,P,DIFICORR,P,RES,RES)
	
	dif=c8*(canthet1-thet1)/mdis

	diflog=dlog(canthet1)-dlog(thet1)


	a=-0.5D0*difdet-0.5d0*gamma1*TIT-dif+diflog

	IF(a.lt.0.0d0) THEN
 		accep=dexp(a)
	ELSE
		accep=1.0d0
	END IF


	CALL DRNUN(1,U) !UnIForm[0,1]

	IF(U.LT.accep)	THEN 
		thet1=canthet1
		phi=canphi

		deter=deter1

		DO I=1,P
			DO J=1,P
				CORR(I,J)=CORR1(I,J)
				ICORR(I,J)=ICORR1(I,J)
			END DO
		END DO

		IF(R.GT.burnin)  thet1change=thet1change+1

	END IF

	END SUBROUTINE GTHETA1