!Sampling theta_2, the smoothness parameter
!INPUT:P,N,RES,phi,DIST,CORR,ICORR,deter,thet2,R,burnin,thet2change,gamma1,omega2,c9,PRIORTHETA,c88
!OUTPUT:thet2



	SUBROUTINE GTHETA2(P,N,RES,phi,DIST,CORR,ICORR,deter,thet2,R,burnin,thet2change,gamma1,omega2,c9,PRIORTHETA,c88)

	USE NUMERICAL_LIBRARIES

	IMPLICIT NONE

	INTEGER :: I, J, P, T,R,burnin,N,PRIORTHETA
	INTEGER:: LDRSIG, IRANK	
	DOUBLE PRECISION :: DIST(N,N), CORR(N,N), ICORR(N,N), deter
	DOUBLE PRECISION :: CORR1(N,N), ICORR1(N,N), deter1, gamma1,omega2
	DOUBLE PRECISION :: phi,thet2,c9,RES(P),c88
	DOUBLE PRECISION :: u1, U, canthet2, a, accep,thet2change
	DOUBLE PRECISION :: difdet, DIFICORR(P,P), dif, TIT
	DOUBLE PRECISION :: clthet2,y,kappa,diflog,dif2

	kappa=3.00D-1 

    !Candidate from Normal(ln(thet2),kappa)

 	CALL DRNNOR(1,clthet2) !N(0,1)
	
	y=dlog(thet2)

	clthet2=clthet2*kappa+y
	
	canthet2=dexp(clthet2)

	CALL GCORRELATION(P,N,DIST,canthet2,phi,omega2,CORR1,ICORR1,deter1)  

	IF(deter1.lt.1.00D-250) THEN 
		deter1=1.00D-250
		PRINT *, 'The determinant is truncated in theta2'
	END IF
		
	difdet=dlog(deter1)-dlog(deter)
	DO I=1,P
		DO J=1,P
			DIFICORR(I,J)=ICORR1(I,J)-ICORR(I,J)
		END DO
	END DO

	TIT=DBLINF(P,P,DIFICORR,P,RES,RES)

	dif=c9*(canthet2-thet2)

	diflog=dlog(canthet2)-dlog(thet2)


	a=-0.5D0*difdet-0.5d0*gamma1*TIT-dif+diflog

	IF(PRIORTHETA.EQ.1) THEN 
		
		dif2=c88/phi*(dsqrt(canthet2)-dsqrt(thet2))

		a=a-dif2+ 0.5d0*diflog

	END IF



	IF(a.lt.0.0d0) THEN
 		accep=dexp(a)
	ELSE
		accep=1.0d0
	END IF


	CALL DRNUN(1,U) !UnIForm[0,1]

	IF(U.LT.accep)	THEN 
		thet2=canthet2

		deter=deter1

		DO I=1,P
			DO J=1,P
				CORR(I,J)=CORR1(I,J)
				ICORR(I,J)=ICORR1(I,J)
			END DO
		END DO

		IF(R.GT.burnin)  thet2change=thet2change+1

	END IF

	END SUBROUTINE GTHETA2