!Drawing beta
!INPUT:P,N,K,KH,EPSILAM,Z,X,XTX,tau2,gamma1,c1,mz,vz,varx,betap
!OUTPUT:BET


	SUBROUTINE HBETA1(P,N,K,KH,EPSILAM,Z,X,XTX,tau2,gamma1,c1,BET,mz,vz,varx,betap)

	USE NUMERICAL_LIBRARIES

	IMPLICIT NONE

!Input+some constants
	INTEGER ::  P, K, T, I, J, LDRSIG, IRANK,N,KH,betap	
	DOUBLE PRECISION :: tau2, gamma1, c1
	DOUBLE PRECISION :: EPSILAM(P), Z(P), X(N,KH), XTX(KH,KH)
	DOUBLE PRECISION :: mz,vz,varx(KH)

!Ouput+intermediate calculations
	DOUBLE PRECISION :: HH(K,K),IHH(K,K), HSIG(K,K),IHSIG(K,K),IHHX(K,P)
	DOUBLE PRECISION :: ZEL(P),BET1(K),BET(K),NORMA(K)

	DOUBLE PRECISION :: cvz

IF(betap.eq.0) then 
	cvz=c1
ELSE
	cvz=c1*vz
END IF


!1.1.- HH=X'X/tau^2+(1/a)*I_k or HH=X'X/tau^2+(1/(c1*varz))*sigma_beta

	HH(1,1)=XTX(1,1)/tau2+1/cvz
	DO I=2,K
		HH(I,I)=XTX(I,I)/tau2+varx(I)/cvz
		DO J=1,I-1
			HH(I,J)=XTX(I,J)/tau2
			HH(J,I)=XTX(J,I)/tau2
		END DO
	END DO

!1.2.- IHH=HH^{-1}

! Cholesky decomposition of HH


	IRANK=K
	LDRSIG=K


	CALL DCHFAC(K, HH, K, 1.00D-100, IRANK, HSIG, LDRSIG)
	
!Inversion of RSIG=IRSIG

	CALL DLINRT(K, HSIG, K, 2,IHSIG, K) !L^{-1} 
	
!IHH=HH^{-1} = L^{-1}*L^{-t}  L is the upper triangular.


	CALL DMXYTF(K,K,IHSIG,K,K,K,IHSIG,K,K,K,IHH,K)

! bet1=IHH*[X'T/tau2+(1/(c1*varz))*sigma_beta*mz]


!1.3.- IHHX=HH^{-1}*X'

	CALL DMXYTF(K,K,IHH,K,P,K,X,N,K,P,IHHX,K)


!1.4.- ZEL=(Z-sigma*EPSI*LAMBDA^{-1/2})/tau2

	DO I=1,P
		ZEL(I)=Z(I)-EPSILAM(I)/dsqrt(gamma1)
		ZEL(I)=ZEL(I)/tau2
	END DO


!1.5.- bet1=IHHX*ZEL

	CALL DMURRV(K,P,IHHX,K,P,ZEL,1,K,bet1)
	
	IF(BETAP.EQ.1) THEN

	!1.5.1.- bet1=BET1+IHH*(1/(c1*varz))*sigma_beta*mz

		DO I=1,K
			bet1(I)=bet1(I)+IHH(I,1)*mz/cvz
		END DO

	END IF
!1.6.-	Normal(bet1, HH^{-1})

	CALL DRNMVN(1,K,IHSIG,K,NORMA,1)


		DO J=1,K
			BET(J)=BET1(J)+NORMA(J)
		END DO
	
	END SUBROUTINE HBETA1