!Drawing SIGMA^-2=gamma1
!INPUT:P,EPSILAM,omega2,RES,c2,c3,R,burnin,gamma1
!OUTPUT:gamchange,gamma1


	SUBROUTINE ISIGMA(P,EPSILAM,omega2,RES,c2,c3,R,burnin,gamchange,gamma1)

	USE NUMERICAL_LIBRARIES

	IMPLICIT NONE

!Input+some constants
	INTEGER ::  P, T, I, J, R,burnin	
	DOUBLE PRECISION ::  gamchange,gamma1, EPSILAM(P),c2, c3, RES(P), omega2

!Ouput+intermediate calculations
	DOUBLE PRECISION :: clgamma, kappa, y, dy1, dy2, dy3, cangamma
	DOUBLE PRECISION :: tt, c11, c21, c31, a1, accep, U

	kappa=2.00D-1 

!Candidate from Normal(ln(gamma1),kappa^2)

 	CALL DRNNOR(1,clgamma) !N(0,1)
	
	y=dlog(gamma1)

	clgamma=clgamma*kappa+y
	
	cangamma=dexp(clgamma)
!a1
	dy1=clgamma-y
	dy2=cangamma-gamma1
	dy3=dsqrt(cangamma)-dsqrt(gamma1)
	
	c21=(c2+P/2.00d0)

	tt=0
	DO I=1,P
		tt=tt+RES(I)**2
	END DO

	c31=c3+tt/(2*OMEGA2)

	c11=0
	DO I=1,P
		c11=c11+EPSILAM(I)*RES(I)
	END DO
	c11=c11/omega2

	a1=c21*dy1-c31*dy2+c11*dy3

	IF(a1.lt.0.0d0) THEN
 		accep=dexp(a1)
	ELSE
		accep=1.0d0
	END IF

	CALL DRNUN(1,U) !UnIForm[0,1]


	IF(U.LT.accep)	THEN
		gamma1=cangamma
		
		IF(R.GT.burnin) 	gamchange=gamchange+1

	END IF

	END SUBROUTINE ISIGMA