!Sampling LAMBDAS with lambda_i=1
!OUTPUT:LAM, lamchange

!MA: the biggest cluster
!MI: the smallest cluster
	
	SUBROUTINE 	LAMBDA1(IB,NC,NCLUS, P,N, OMEGA2,CORR,ICORR,EPSI,LNU, gamma1, RES, LAM, lamchange, MC,Rsim, burnin, MA, MI,B12)

	IMPLICIT NONE

	INTEGER :: I, J, P, T, K, R, II, JJ, MC, NCLUS(MC), LDRSIG, IRANK, PM, Rsim, burnin, MA, MI,N,IB,NC
	DOUBLE PRECISION :: XI(P), UX(P), DX(P), W2(P), PI, DEL(P), NDEN(P), ABI(P), SIGEPSI(P),B12
	DOUBLE PRECISION :: CORR(N,N), ICORR(N,N), OMEGA2, LAM(P),  EPSI(P), LNU, gamma1, RES(P)
	DOUBLE PRECISION :: ISIGMA(P,P), SIGMAI(MA,MA), ISIGMAI(MA,MA), BI(P)
	DOUBLE PRECISION :: DNORDF, C1(P-MI,P-MI), IC1(P-MI,P-MI), C2(MA,P-MI)
	DOUBLE PRECISION :: CC211(MA,P-MI), UNI(P-MI), UCC(MA), LAM1(P-MI), CLAM(P-MI)
	DOUBLE PRECISION :: C21LAM(MA), C22LAM(MA), SMEAN(MA), MLAM(MA)
	DOUBLE PRECISION :: SIG1(MA,MA), C22(MA,MA), LAM11(MA), LAMCAN(P)
	DOUBLE PRECISION :: RG(P), ER, ERCAN, LB, LBCAN, a, accep, U, lamchange(MC)
	DOUBLE PRECISION :: MLAM1(MA), BSIGMAI(MA,MA)
	DOUBLE PRECISION :: LAMCANI(MA),LAMCANI1(MA),LAMCANI2(MA)
	DOUBLE PRECISION :: CORRI(MA,MA),ICORRI(MA,MA),RSIGI(MA,MA),deter1
	DOUBLE PRECISION :: CORRI2(MA,MA),ICORRI2(MA,MA),RSIGI2(MA,MA),deter2
	DOUBLE PRECISION :: B1,B2,B3,DBLINF,Bcan

PI=3.141593D0

PM=P-MI

DO I=1,PM
	UNI(I)=1.0D0
END DO

	DO I=1,MA
		DO J=1,MA
			isigmai(I,J)=0.0d0
		END DO
	END DO

	DO I=1,P
			LAMCAN(I)=0.0d0
	END DO

!**1
!w_i^2 and b_i

DO I=1,P
	IF(EPSI(I).LT.0.0D0) THEN 
			SIGEPSI(I)=-1.0D0
		ELSE 
			SIGEPSI(I)=1.0D0
	END IF
END DO

DO I=1,P
	RG(I)=sqrt(gamma1)*RES(I)	!MH
	XI(I)=SIGEPSI(I)*RG(I)/sqrt(omega2)			!x_i
	NDEN(I)=exp(-0.5D0*(XI(I)**2))/sqrt(2.0d0*pi)	!Gaussian density
	DEL(I)=NDEN(I)/DNORDF(XI(I))				!delta(x_i)
	UX(I)=XI(I)**2+XI(I)* DEL(I)+1				!numerator
	DX(I)=(XI(I)+DEL(I))**2.0D0					!denominator
	W2(I)=4*dlog(UX(I)/DX(I))					!w^2
	ABI(I)=(EPSI(I)/DX(I))**2				!part of b_i to sample lambdas
	BI(I)=dlog(ABI(I)*UX(I)/omega2)		!b_i
END DO

!**2

!Sigma^{-1}=ISIGMA

	DO I=1,P-1
		ISIGMA(I,I)=ICORR(I,I)/LNU+1/W2(I)
		DO J=I+1,P
			ISIGMA(I,J)=ICORR(I,J)/LNU
			ISIGMA(J,I)=ISIGMA(I,J)
		END DO 
	END DO
	ISIGMA(P,P)=ICORR(P,P)/LNU+1/W2(P)


!************************************************
! LOOP

R=0
DO K=1,MC !NUMBER OF CLUSTERS
	T=P-NCLUS(K)
!**3

	!Sigma^{-1}_(i)=ISIGMAI
		
	DO I=1,NCLUS(K)
		DO J=1,NCLUS(K)
			ISIGMAI(I,J)=ISIGMA(R+I,R+J)
		END DO
	END DO

	!Sigma_(i)=SIGMAI Inverse of Sigma^{-1}_(i)

	CALL DLINDS(NCLUS(K),ISIGMAI,MA,SIGMAI,MA)

!**4
	
	!C_11=C1

	IF(K.EQ.1) THEN
		DO I=1,T
			DO J=1,T
				C1(I,J)=CORR(I+NCLUS(K),J+NCLUS(K))
			END DO
		END DO
	ELSE IF(K.EQ.MC) THEN
		DO I=1,T
			DO J=1,T
				C1(I,J)=CORR(I,J)
			END DO
		END DO
	ELSE
		DO I=1,R
			DO J=1,R
				C1(I,J)=CORR(I,J)
			END DO
			DO J=R+1,T
				JJ=J+NCLUS(K)
				C1(I,J)=CORR(I,JJ)
			END DO
		END DO
		DO I=R+1,T
			II=I+NCLUS(K)
			DO J=1,R
				C1(I,J)=CORR(II,J)
			END DO
			DO J=R+1,T
				JJ=J+NCLUS(K)
				C1(I,J)=CORR(II,JJ)
			END DO
		END DO
	END IF

!**5

	!(C_11)^{-1}

	CALL DLINDS(T,C1,PM,IC1,PM)


!**6

	!C_21
	
	DO I=1,NCLUS(K)
		DO J=1,T
			IF(K.EQ.1) THEN
				C2(I,J)=CORR(I,J+NCLUS(K))
			ELSE IF(K.EQ.MC) THEN
				C2(I,J)=CORR(I+R,J)
			ELSE
				IF(J.LE.R) THEN
					C2(I,J)=CORR(I+R,J)
				ELSE
					C2(I,J)=CORR(I+R,J+NCLUS(K))
				END IF
			END IF
		END DO
	END DO

!**7

	!C^22 
	DO I=1,NCLUS(K)
		DO J=1,NCLUS(K)
			C22(I,J)=ICORR(R+I,R+J)
		END DO
	END DO

!*************************************************************		
!**8
	! C_21*C_11^{-1}=C2*IC1
	
	CALL DMRRRR(NCLUS(K), T,C2,MA,T,T,IC1,PM,NCLUS(K), T,CC211,MA)

!**9
	! C_21*C_11^{-1}*1=C2*IC1*UNI=UCC

	CALL DMURRV(NCLUS(K),T,CC211,MA,T,UNI,1,NCLUS(K), UCC)

!**10
	! C_21*C_11^{-1}*1-1=C2*IC1*UNI-1=UCC

	DO I=1,NCLUS(K)
		UCC(I)=UCC(I)-1.0D0
	END DO

!**11	

	!LAMBDA_(-I)
	DO I=1,T
		IF(K.EQ.1) THEN
			LAM1(I)=dlog(LAM(I+NCLUS(K)))
		ELSE IF(K.EQ.MC) THEN
			LAM1(I)=dlog(LAM(I))
		ELSE IF(I.LE.R) THEN
			LAM1(I)=dlog(LAM(I))
		ELSE
			LAM1(I)=dlog(LAM(I+NCLUS(K)))
		END IF
	END DO

!**12
	!C_21*C_11^{-1}*LAMBDA_(-I)=CLAM
	
	CALL DMURRV(NCLUS(K),T,CC211,MA,T,LAM1,1,NCLUS(K),CLAM)

!**13
	!LNU/2*UCC-CLAM=C21LAM

	DO I=1,NCLUS(K)
		C21LAM(I)=LNU*0.5D0*UCC(I)+CLAM(I)
	END DO

!**14
	!LNU^{-1}*C^22*C21LAM=C22LAM

	CALL DMURRV(NCLUS(K),NCLUS(K),C22,MA,NCLUS(K),C21LAM,1,NCLUS(K),C22LAM)

	DO I=1,NCLUS(K)
		C22LAM(I)=C22LAM(I)/LNU
	END DO
	
!**15
	!C22LAM+diag(w^{-2})*b_(i)
	
	DO I=1,NCLUS(K)
		SMEAN(I)=C22LAM(I)+BI(R+I)/W2(R+I)
	END DO

!**16
	!MEAN OF LAMBDA_(I)=SIGMAI*SMEAN

CALL DMURRV(NCLUS(K),NCLUS(K),SIGMAI,MA,NCLUS(K),SMEAN,1,NCLUS(K),MLAM)
	
IF(K.EQ.NC) THEN
	IF(IB.EQ.1) THEN
		DO I=1,NCLUS(K)-1
			MLAM1(I)=MLAM(I+1)
		END DO
	ELSE IF(IB.EQ.NCLUS(K)) THEN
		DO I=1,NCLUS(K)-1
			MLAM1(I)=MLAM(I)
		END DO
	ELSE 
		DO I=1,IB-1
			MLAM1(I)=MLAM(I)
		END DO
		DO I=IB,NCLUS(K)-1
			MLAM1(I)=MLAM(I+1)
		END DO
	END IF
END IF
!***************************************************************
!**17 

IF(K.EQ.NC) THEN
	
	! CHOLESKY DECOMPOSITION OF BSIGMAI

	
	IF(IB.EQ.1) THEN
		DO I=1,NCLUS(K)-1
			DO J=I,NCLUS(K)-1
				BSIGMAI(I,J)=SIGMAI(I+1,J+1)
				BSIGMAI(J,I)=BSIGMAI(I,J)
			END DO
		END DO
	ELSE IF(IB.EQ.NCLUS(K)) THEN
		DO I=1,NCLUS(K)-1
			DO J=I,NCLUS(K)-1
				BSIGMAI(I,J)=SIGMAI(I,J)
				BSIGMAI(J,I)=BSIGMAI(I,J)
			END DO
		END DO
	ELSE
		DO I=1,IB-1
			DO J=I,IB-1
				BSIGMAI(I,J)=SIGMAI(I,J)
				BSIGMAI(J,I)=BSIGMAI(I,J)
			END DO
			DO J=IB,NCLUS(K)-1
				BSIGMAI(I,J)=SIGMAI(I,J+1)
				BSIGMAI(J,I)=BSIGMAI(I,J)
			END DO
		END DO
		DO I=IB,NCLUS(K)-1
			DO J=I,NCLUS(K)-1
				BSIGMAI(I,J)=SIGMAI(I+1,J+1)
				BSIGMAI(J,I)=BSIGMAI(I,J)
			END DO
		END DO
	END IF


	LDRSIG=MA
	IRANK=NCLUS(K)-1

	CALL DCHFAC(NCLUS(K)-1, BSIGMAI, MA, 1.00D-20, IRANK, SIG1, LDRSIG)

	CALL DRNMVN(1,NCLUS(K)-1,SIG1,MA,LAM11,1)

	DO I=1,NCLUS(K)-1
		LAMCANI(I)=dexp(MLAM1(I)+LAM11(I))
	END DO

	LAMCAN(R+IB)=1
	IF(IB.EQ.1) THEN
		DO I=2,NCLUS(K)
			LAMCAN(R+I)=LAMCANI(I-1)
		END DO
	ELSE IF(IB.EQ.NCLUS(K)) THEN
		DO I=1,NCLUS(K)-1
			LAMCAN(R+I)=LAMCANI(I)
		END DO
	ELSE
		DO I=1,IB-1
			LAMCAN(R+I)=LAMCANI(I)
		END DO

		DO I=IB+1,NCLUS(K)
			LAMCAN(R+I)=LAMCANI(I-1)
		END DO
	END IF


!Calculation of the expentancy (13)


	!C_(-i)=CORRI


	IF(IB.EQ.1) THEN
		DO I=1,NCLUS(K)-1
			DO J=I,NCLUS(K)-1
				CORRI(I,J)=CORR(R+I+1,R+J+1)
				CORRI(J,I)=CORRI(I,J)
			END DO
		END DO
	ELSE IF(IB.EQ.NCLUS(K)) THEN
		DO I=1,NCLUS(K)-1
			DO J=I,NCLUS(K)-1
				CORRI(I,J)=CORR(R+I,R+J)
				CORRI(J,I)=CORRI(I,J)
			END DO
		END DO
	ELSE
		DO I=1,IB-1
			DO J=I,IB-1
				CORRI(I,J)=CORR(R+I,R+J)
				CORRI(J,I)=CORRI(I,J)
			END DO
			DO J=IB,NCLUS(K)-1
				CORRI(I,J)=CORR(R+I,R+J+1)
				CORRI(J,I)=CORRI(I,J)
			END DO
		END DO
		DO I=IB,NCLUS(K)-1
			DO J=I,NCLUS(K)-1
				CORRI(I,J)=CORR(R+I+1,R+J+1)
				CORRI(J,I)=CORRI(I,J)
			END DO
		END DO
	END IF

	LDRSIG=MA 
	IRANK=NCLUS(K)-1	 

	CALL DCHFAC(NCLUS(K)-1, CORRI, MA, 1.00D-100, IRANK, RSIGI, LDRSIG)

	!C_(-i)^-1=ICORRI

!Inverse matrix ICORRI
	CALL DLINDS(NCLUS(K)-1,CORRI,MA,ICORRI,MA)


! Determinant of CORRI
	deter1=1
	DO I=1,NCLUS(K)-1
		deter1=deter1*RSIGI(I,I)**2
	END DO

	!C_(-i)-c_i*c_i'=CORRI2


	IF(IB.EQ.1) THEN
		DO I=1,NCLUS(K)-1
			DO J=I,NCLUS(K)-1
				CORRI2(I,J)=CORR(R+I+1,R+J+1)-CORR(R+I+1,R+1)*CORR(R+J+1,R+1)
				CORRI2(J,I)=CORRI2(I,J)
			END DO
		END DO
	ELSE IF(IB.EQ.NCLUS(K)) THEN
		DO I=1,NCLUS(K)-1
			DO J=I,NCLUS(K)-1
				CORRI2(I,J)=CORR(R+I,R+J)-CORR(R+I,R+NCLUS(K))*CORR(R+J,R+NCLUS(K))
				CORRI2(J,I)=CORRI2(I,J)
			END DO
		END DO
	ELSE
		DO I=1,IB-1
			DO J=I,IB-1
				CORRI2(I,J)=CORR(R+I,R+J)-CORR(R+I,R+IB)*CORR(R+J,R+IB)
				CORRI2(J,I)=CORRI2(I,J)
			END DO
			DO J=IB,NCLUS(K)-1
				CORRI2(I,J)=CORR(R+I,R+J+1)-CORR(R+I,R+IB)*CORR(R+J+1,R+IB)
				CORRI2(J,I)=CORRI2(I,J)
			END DO
		END DO
		DO I=IB,NCLUS(K)-1
			DO J=I,NCLUS(K)-1
				CORRI2(I,J)=CORR(R+I+1,R+J+1)-CORR(R+I+1,R+IB)*CORR(R+J+1,R+IB)
				CORRI2(J,I)=CORRI2(I,J)
			END DO
		END DO
	END IF

	
	CALL DCHFAC(NCLUS(K)-1, CORRI2, MA, 1.00D-100, IRANK, RSIGI2, LDRSIG)

	!(C_(-i)-c_i*c_i')^-1=ICORRI2

!Inverse matrix ICORRI2
	CALL DLINDS(NCLUS(K)-1,CORRI2,MA,ICORRI2,MA)

! Determinant of CORRI2
	deter2=1
	DO I=1,NCLUS(K)-1
		deter2=deter2*RSIGI2(I,I)**2
	END DO

![ln(LAMBDA_(-i))+nu/2*1]'*C_(-i)^-1*[ln(LAMBDA_(-i))+nu/2*1]

	DO I=1,NCLUS(K)-1
		LAMCANI1(I)=LAMCANI(I)+LNU*0.5D0
	END DO


	B1=DBLINF(NCLUS(K)-1,NCLUS(K)-1,ICORRI,MA,LAMCANI1,LAMCANI1)

![ln(LAMBDA_(-i))+nu/2*(1-c_i)]'*[C_(-i)-c_i*c_i']^-1*[ln(LAMBDA_(-i))+nu/2*(1-c_i)]


	IF(IB.EQ.1) THEN
		DO I=1,NCLUS(K)-1
			LAMCANI2(I)=LAMCANI(I)+LNU*0.5D0*(1-CORR(R+I+1,R+1))
		END DO
	ELSE IF(IB.EQ.NCLUS(K)) THEN
		DO I=1,NCLUS(K)-1
			LAMCANI2(I)=LAMCANI(I)+LNU*0.5D0*(1-CORR(R+I,R+NCLUS(K)))
		END DO
	ELSE
		DO I=1,IB-1
			LAMCANI2(I)=LAMCANI(I)+LNU*0.5D0*(1-CORR(R+I,R+IB)) 
		END DO
		DO I=IB,NCLUS(K)-1
			LAMCANI2(I)=LAMCANI(I)+LNU*0.5D0*(1-CORR(R+I+1,R+IB))
		END DO
	END IF


	B2=DBLINF(NCLUS(K)-1,NCLUS(K)-1,ICORRI2,MA,LAMCANI2,LAMCANI2)


B3=-0.5D0*((dlog(deter1)-dlog(deter2))-(B1-B2)/lnu)

Bcan=dexp(B3)

ELSE

	!CHOLESKY DECOMPOSITION OF SIGMAI

	LDRSIG=MA
	IRANK=NCLUS(K) 

	CALL DCHFAC(NCLUS(K), SIGMAI, MA, 1.00D-20, IRANK, SIG1, LDRSIG)

	CALL DRNMVN(1,NCLUS(K),SIG1,MA,LAM11,1)

	DO I=1,NCLUS(K)
		LAMCAN(R+I)=dexp(MLAM(I)+LAM11(I))
	END DO
	
END IF

!*****************************************************

	!METROPOLIS-HASTING

	ER=0
	ERCAN=0
	LB=0
	LBCAN=0

	DO I=1,NCLUS(K)
		ER=ER+(EPSI(R+I)/sqrt(LAM(R+I))-RG(R+I))**2
		ERCAN=ERCAN+(EPSI(R+I)/sqrt(LAMCAN(R+I))-RG(R+I))**2
		LB=LB+(dlog(LAM(R+I))-BI(R+I))**2/W2(R+I)
		LBCAN=LBCAN+(dlog(LAMCAN(R+I))-BI(R+I))**2/W2(R+I)
	END DO

	a=0.5d0*(((ER-ERCAN)/omega2)+LBCAN-LB)

	IF(a.lt.0.0d0) THEN
 		accep=dexp(a)
	ELSE
		accep=1.0d0
	END IF

	CALL DRNUN(1,U) !Uniform[0,1]

	IF(U.LT.accep)	THEN 
		
		DO I=1,NCLUS(K)
			LAM(R+I)=LAMCAN(R+I)
		END DO
	
		IF(Rsim.GT.burnin) THEN
			lamchange(k)=lamchange(k)+1
			
			IF(K.EQ.NC) b12=bcan  !Expectancy (13)

		END IF

	END IF

	R=R+NCLUS(K)

	END DO

	END SUBROUTINE LAMBDA1