
SUBROUTINE  MOMENT6(P,N,K,KH,sim,Msig,Vsig,Mbet,Varbet1,Mrang,Vrang, &
		Mlambda, Vlambda, Mthet2, Vthet2, Mlnu,Vlnu,   &
		Mepsi, Vepsi, Momega,Vomega,Ms,Vs,Mrho,Vrho,Msnu,Vsnu,Mtsnu,Vtsnu,Mtau,Vtau)

	IMPLICIT NONE

	INTEGER :: P, K, I, J, R, sim,N,KH
	DOUBLE PRECISION :: Msig, Vsig, Mbet(K), Varbet1(KH,KH), Mrang, Vrang,Mtau,Vtau
	DOUBLE PRECISION :: Mlambda(P), Vlambda(N,N), Mepsi(P), Vepsi(N,N)
	DOUBLE PRECISION :: Mthet2, Vthet2, Mlnu,Vlnu, Momega,Vomega,Ms,Vs,Mrho,Vrho,Msnu,Vsnu,Mtsnu,Vtsnu

!------------------------------------------
!Moments

!Empirically

!E*[isigma]=Msig, Var*[isigma]=Vsig, E*[B]=Mbet
!E*[range]=Mrang and Var*[range]=Vrang


	Msig=Msig/sim
	Vsig=Vsig/sim-Msig**2
	Mrang=Mrang/sim
	Vrang=Vrang/sim-Mrang**2
	Mthet2=Mthet2/sim
	Vthet2=Vthet2/sim-Mthet2**2
	Mlnu=Mlnu/sim
	Vlnu=Vlnu/sim-Mlnu**2
	Momega=Momega/sim
	Vomega=Vomega/sim-Momega**2
	Ms=Ms/sim
	Vs=Vs/sim-Ms**2
	Mrho=Mrho/sim
	Vrho=Vrho/sim-Mrho**2
	Msnu=Msnu/sim
	Vsnu=Vsnu/sim-Msnu**2
	Mtsnu=Mtsnu/sim
	Vtsnu=Vtsnu/sim-Mtsnu**2
	Mtau=Mtau/sim
	Vtau=Vtau/sim-Mtau**2

	DO I=1,k
		Mbet(I)=Mbet(I)/sim
	END DO

	DO I=1,P
		Mlambda(I)=Mlambda(I)/sim
		Mepsi(I)=Mepsi(I)/sim
	END DO

!Covariance matrix of Beta

!E[BB']

DO i=1,k
	DO j=1,k
		Varbet1(i,j)=Varbet1(i,j)/sim-Mbet(i)*Mbet(j)
	END DO
END DO

!Variance matrix of Lambda and Epsilon


DO i=1,P
	DO j=1,P
		Vlambda(i,j)=Vlambda(i,j)/sim-Mlambda(i)*Mlambda(j)
		Vepsi(i,j)=Vepsi(i,j)/sim-Mepsi(i)*Mepsi(j)
	END DO
END DO

END SUBROUTINE MOMENT6