!Sampling nu
!INPUT: P,N,LAM,ICORR,R,burnin,lnuchange,xlamnu,lnu,c6,c7,clam67
!OUTPUT: lnuchange,lnu



	SUBROUTINE nudraw(P,N,LAM,ICORR,R,burnin,lnuchange,xlamnu,lnu,c6,c7,clam67)

	USE NUMERICAL_LIBRARIES

	IMPLICIT NONE

	INTEGER :: I, J, P, T,R,burnin,N
	DOUBLE PRECISION ::  ICORR(N,N),c6,c7,clam67
	DOUBLE PRECISION :: LAM(P), lnu
	DOUBLE PRECISION :: u1, U, canlnu, a, accep,lnuchange, kappa
	DOUBLE PRECISION :: LOGLAM(P), dIF, dIFlog,dIFinv
	DOUBLE PRECISION :: cllnu,y,xgamlnu1,xgamlnu2,xgamlnu3,xlamnu

	xlamnu=clam67-P/2.0d0   !lambda
	
	kappa=5.00D-1 

    !Candidate from Normal(ln(lnu),kappa)

 	CALL DRNNOR(1,cllnu) !N(0,1)
	
	y=dlog(lnu)

	cllnu=cllnu*kappa+y
	
	canlnu=dexp(cllnu)


	xgamlnu1=0.0d0
	DO I=1,P
		DO J=1,P
			xgamlnu1=xgamlnu1+ICORR(I,J)
		END DO
	END DO
	
	xgamlnu2=c7**2+xgamlnu1/4.0d0

	DO I=1,P
		LOGLAM(I)=dlog(LAM(I))
	END DO

	xgamlnu3=DBLINF(P,P,ICORR,N,LOGLAM,LOGLAM)
	xgamlnu3=xgamlnu3+c6**2

	dIFlog=xlamnu*(dlog(canlnu)-dlog(lnu))

	dIFinv=xgamlnu3*(1/canlnu-1/lnu)

	dIF=xgamlnu2*(canlnu-lnu)

	

	a=dIFlog-0.5d0*(dIFinv+dIF)

	IF(a.lt.0.0d0) THEN
 		accep=dexp(a)
	ELSE
		accep=1.0d0
	END IF


	CALL DRNUN(1,U) !UnIForm[0,1]

	IF(U.LT.accep)	THEN 
		lnu=canlnu

		IF(R.GT.burnin)  lnuchange=lnuchange+1

	END IF

END SUBROUTINE nudraw