!Sampling omega2
!INPUT:P,N,RES,EPSILAM,ICORR,gamma1,R,burnin,omegachange,c4,c5,clam45,omega2
!OUTPUT:omegachange,omega2



	SUBROUTINE omegdraw(P,N,RES,EPSILAM,ICORR,gamma1,R,burnin,omegachange,c4,c5,clam45,omega2)

	USE NUMERICAL_LIBRARIES

	IMPLICIT NONE

	INTEGER :: I, J, P, T,R,burnin,N
	DOUBLE PRECISION ::  ICORR(N,N),EPSILAM(P),RES(P), gamma1,omega2
	DOUBLE PRECISION :: u1, U, omegacan, a, accep, omegachange, kappa
	DOUBLE PRECISION :: REPSILAM(P), dIF, dIFlog,dIFinv
	DOUBLE PRECISION :: clomega2,y,xgamma2,xgamma3,xlambda,c4,c5,clam45

	xlambda=clam45-P/2.0d0  !lambda

	kappa=5.00D-1 

    !Candidate from Normal(ln(omega2),kappa)

 	CALL DRNNOR(1,clomega2) !N(0,1)
	
	y=dlog(omega2)

	clomega2=clomega2*kappa+y
	
	omegacan=dexp(clomega2)


	!REPSILAM=Z-XB-sigma*lambda^{-1/2}*epsilon

	xgamma2=0.0d0   !T'T
	DO I=1,P
		REPSILAM(I)=RES(I)-EPSILAM(I)/dsqrt(gamma1)
		xgamma2=xgamma2+REPSILAM(I)**2
	END DO

	xgamma3=gamma1*xgamma2+c4**2  !delta^2=T'T/sigma^2

	dIFlog=xlambda*(dlog(omegacan)-dlog(omega2))

	dIFinv=xgamma3*(1/omegacan-1/omega2)

	dIF=(omegacan-omega2)*c5**2

	
	a=dIFlog-0.5d0*(dIFinv+dIF)

	IF(a.lt.0.0d0) THEN
 		accep=dexp(a)
	ELSE
		accep=1.0d0
	END IF


	CALL DRNUN(1,U) !UnIForm[0,1]

	IF(U.LT.accep)	THEN 
		omega2=omegacan

		IF(R.GT.burnin)  omegachange=omegachange+1

	END IF


END SUBROUTINE omegdraw