!Sampling theta_1, the range
!INPUT:P,N,LAM,EPSI,lnu,thet2,DIST,CORR,ICORR,deter,c8,mdis,phi,thet1,R,burnin,thet1change
!OUTPUT:phi,thet1,thet1change



	SUBROUTINE THETA1(P,N,LAM,EPSI,lnu,thet2,DIST,CORR,ICORR,deter,c8,mdis,phi,thet1,R,burnin,thet1change)

	USE NUMERICAL_LIBRARIES

	IMPLICIT NONE

	INTEGER :: I, J, P, T,R,burnin,N
	INTEGER:: LDRSIG, IRANK	
	DOUBLE PRECISION :: DIST(N,N), CORR(N,N), ICORR(N,N), deter
	DOUBLE PRECISION :: CORR1(N,N), ICORR1(N,N), deter1
	DOUBLE PRECISION :: LAM(P), EPSI(P),lnu,phi,thet2,thet1
	DOUBLE PRECISION :: u1, U, canthet1, a, c8, accep,thet1change, kappa
	DOUBLE PRECISION :: LAMNU(P), difdet, DIFICORR(P,P), dif, diflog, EIE,LIL
	DOUBLE PRECISION :: clthet1,y,canphi,mdis

	kappa=1.50D-1 

    !Candidate from Normal(ln(thet1),kappa)

 	CALL DRNNOR(1,clthet1) !N(0,1)
	
	y=dlog(thet1)

	clthet1=clthet1*kappa+y
	
	canthet1=dexp(clthet1)


	!log(lambda)+nu*1/2=lamnu

	DO I=1,P
		LAMNU(I)=dlog(LAM(I))+lnu*0.5d0
	END DO

	canphi=1/canthet1

	CALL CORRELATION6(P,N,DIST,thet2,canphi,CORR1,ICORR1,deter1)
		
	IF(deter1.lt.1.00D-250) THEN
		deter1=1.00D-250
		PRINT *, 'The determinant is truncated in theta1'
	END IF
	
	difdet=dlog(deter1)-dlog(deter)
	DO I=1,P
		DO J=1,P
			DIFICORR(I,J)=ICORR1(I,J)-ICORR(I,J)
		END DO
	END DO

	EIE=DBLINF(P,P,DIFICORR,P,EPSI,EPSI)
	
	LIL=DBLINF(P,P,DIFICORR,P,LAMNU,LAMNU)

	dif=c8*(canthet1-thet1)/mdis

	diflog=dlog(canthet1)-dlog(thet1)


	a=-difdet-0.5d0*EIE-0.5D0*LIL/lnu-dif+diflog

	IF(a.lt.0.0d0) THEN
 		accep=dexp(a)
	ELSE
		accep=1.0d0
	END IF


	CALL DRNUN(1,U) !UnIForm[0,1]

	IF(U.LT.accep)	THEN 
		thet1=canthet1
		phi=canphi

		deter=deter1

		DO I=1,P
			DO J=1,P
				CORR(I,J)=CORR1(I,J)
				ICORR(I,J)=ICORR1(I,J)
			END DO
		END DO

		IF(R.GT.burnin)  thet1change=thet1change+1

	END IF


END SUBROUTINE THETA1