!Sampling theta_2, the smoothness parameter
!INPUT:P,N,LAM,EPSI,lnu,phi,DIST,CORR,ICORR,deter,thet2,R,burnin,thet2change,c9,PRIORTHETA,c88
!OUTPUT:thet2,thet2change



	SUBROUTINE THETA2(P,N,LAM,EPSI,lnu,phi,DIST,CORR,ICORR,deter,thet2,R,burnin,thet2change,c9,PRIORTHETA,c88)


	USE NUMERICAL_LIBRARIES

	IMPLICIT NONE

	INTEGER :: I, J, P, T,R,burnin,N,PRIORTHETA
	INTEGER:: LDRSIG, IRANK	
	DOUBLE PRECISION :: DIST(N,N), CORR(N,N), ICORR(N,N), deter
	DOUBLE PRECISION :: CORR1(N,N), ICORR1(N,N), deter1
	DOUBLE PRECISION :: LAM(P), EPSI(P),lnu,phi,thet2,c9,c88
	DOUBLE PRECISION :: u1, U, canthet2, a, accep,thet2change
	DOUBLE PRECISION :: LAMNU(P), difdet, DIFICORR(P,P), dif,  EIE,LIL
	DOUBLE PRECISION :: clthet2,y,kappa,diflog,dif2

	kappa=1.50D-1 

    !Candidate from Normal(ln(thet2),kappa)

 	CALL DRNNOR(1,clthet2) !N(0,1)
	
	y=dlog(thet2)

	clthet2=clthet2*kappa+y
	
	canthet2=dexp(clthet2)

	!log(lambda)+nu*1/2=lamnu

	DO I=1,P
		LAMNU(I)=dlog(LAM(I))+lnu*0.5d0
	END DO

	CALL CORRELATION6(P,N,DIST,canthet2,phi,CORR1,ICORR1,deter1)  

	IF(deter1.lt.1.00D-250) THEN 
		deter1=1.00D-250
		print *, 'The determinant is truncated in theta2'
	END IF
		
	difdet=dlog(deter1)-dlog(deter)
	DO I=1,P
		DO J=1,P
			DIFICORR(I,J)=ICORR1(I,J)-ICORR(I,J)
		END DO
	END DO

	EIE=DBLINF(P,P,DIFICORR,P,EPSI,EPSI)
	
	LIL=DBLINF(P,P,DIFICORR,P,LAMNU,LAMNU)

	dif=c9*(canthet2-thet2)

	diflog=dlog(canthet2)-dlog(thet2)


	a=-difdet-0.5d0*EIE-0.5D0*LIL/lnu-dif+diflog


	IF(PRIORTHETA.EQ.1) THEN 

		dif2=c88/phi*(dsqrt(canthet2)-dsqrt(thet2))

		a=a-dif2+ 0.5d0*diflog

	ENDIF

	IF(a.lt.0.0d0) THEN
 		accep=dexp(a)
	ELSE
		accep=1.0d0
	END IF


	CALL DRNUN(1,U) !UnIForm[0,1]

	IF(U.LT.accep)	THEN 
		thet2=canthet2

		deter=deter1

		DO I=1,P
			DO J=1,P
				CORR(I,J)=CORR1(I,J)
				ICORR(I,J)=ICORR1(I,J)
			END DO
		END DO

		IF(R.GT.burnin)  thet2change=thet2change+1

	END IF



END SUBROUTINE THETA2