!This subroutine calculates the design matrix 
!INPUT: ALLDATA,P,N,MV,K,KH,K1,K2
!OUTPUT: X,XTX,rx,ry

	SUBROUTINE DESIGN1(ALLDATA,P,N,MV,K,KH,K1,K2,X, XTX,rx,ry)

	IMPLICIT NONE

	INTEGER :: I, J, P, K, K1, K2, ip, R, T,N,MV,KH,K12
	DOUBLE PRECISION :: ALLDATA(N,MV)
	DOUBLE PRECISION :: X(N,KH)
	DOUBLE PRECISION :: rx(2), ry(2), ox, oy, sx, sy, XX(P),YY(P),XTX(KH,KH)


!1.- Scaling

	DO I=1,2
		rx(I)=ALLDATA(1,2)
		ry(I)=ALLDATA(1,3)
	END DO

	DO I=2,P
		IF (ALLDATA(I,2).LT.rx(1)) rx(1)=ALLDATA(I,2) !Min x
		IF (ALLDATA(I,2).GT.rx(2)) rx(2)=ALLDATA(I,2) !Max x
		IF (ALLDATA(I,3).LT.ry(1)) ry(1)=ALLDATA(I,3) !Min y
		IF (ALLDATA(I,3).GT.ry(2)) ry(2)=ALLDATA(I,3) !Max y
	END DO	
	
	ox =(rx(2) + rx(1))/2
	sx = 2/(rx(2) - rx(1))
	oy = (ry(2) + ry(1))/2
	sy = 2/(ry(2) - ry(1))
	
	DO I=1,P
		XX(I) = sx * (ALLDATA(I,2) - ox)
		YY(I) = sy * (ALLDATA(I,3) - oy)
	END DO

!2.-Design matrix

! (1, x, x^2, y, xy, y^2)

	DO I=1,P
		ip=0
		DO J=0,K2
			IF(K1.EQ.0) THEN
				ip=ip+1
				X(I,ip)=YY(I)**J
			ELSE					
				IF(K1.GE.K2) THEN
					DO R=0,K1-J
						ip=ip+1
						X(I,ip)=(XX(I)**R)*(YY(I)**J)
					END DO
				ELSE
					DO R=0,K1
						ip=ip+1
						X(I,ip)=(XX(I)**R)*(YY(I)**J)
					END DO
				ENDIF
			ENDIF
		END DO
	END DO			

	K12=2+K1+K2
	
	IF(K.NE.K12)  THEN
		IF((K1.EQ.2.AND.K2.EQ.2).OR.(K1.EQ.1.AND.K2.EQ.2)) THEN
			DO I=1,P
				X(I,K)=X(I,K12)
			END DO
		END IF
	END IF


!X'X=XTX

	CALL DMXTXF(P,K,X,N,K,XTX,KH)

	END SUBROUTINE DESIGN1