!This subroutine calculates:
!	1.- the design matrix for the points to predict: XP
!	2.- the distance matrix between the sample points and the points to predict: PDIST1

!OUTPUT: XP,PDIST1

	SUBROUTINE prepred1(ALLDATA,P,N,MV,K,KH,K1,K2,npr,ZP1,ZP2,XP,PDIST1)

	IMPLICIT NONE

	INTEGER :: I, J, P, K, K1, K2, K12, ip, R, T,npr,N,MV,KH
	DOUBLE PRECISION :: ALLDATA(N,MV),ZP(npr,2),ZP1(npr),ZP2(npr)
	DOUBLE PRECISION :: XP(npr,KH),PDIST1(npr,P) 
	DOUBLE PRECISION :: rx(2), ry(2), ox, oy, sx, sy, XX(npr),YY(npr)

!1.- Scaling

	DO I=1,2
		rx(I)=ALLDATA(1,2)
		ry(I)=ALLDATA(1,3)
	END DO

	DO I=2,P
		IF (ALLDATA(I,2).LT.rx(1)) rx(1)=ALLDATA(I,2) !Min x
		IF (ALLDATA(I,2).GT.rx(2)) rx(2)=ALLDATA(I,2) !Max x
		IF (ALLDATA(I,3).LT.ry(1)) ry(1)=ALLDATA(I,3) !Min y
		IF (ALLDATA(I,3).GT.ry(2)) ry(2)=ALLDATA(I,3) !Max y
	END DO	
	
	ox =(rx(2) + rx(1))/2
	sx = 2/(rx(2) - rx(1))
	oy = (ry(2) + ry(1))/2
	sy = 2/(ry(2) - ry(1))
	
	DO I=1,npr
		XX(I) = sx * (zp1(I) - ox)
		YY(I) = sy * (zp2(I) - oy)

	END DO

!2.-Design matrix

! (1, x, x^2, y, xy, y^2)

	DO I=1,npr
		ip=0
		DO J=0,K2
			IF(K1.EQ.0) THEN
				ip=ip+1
				XP(I,ip)=YY(I)**J
			ELSE					
				IF(K1.GE.K2) THEN
					DO R=0,K1-J
						ip=ip+1
						XP(I,ip)=(XX(I)**R)*(YY(I)**J)
					END DO
				ELSE
					DO R=0,K1
						ip=ip+1
						XP(I,ip)=(XX(I)**R)*(YY(I)**J)
					END DO
				ENDIF
			ENDIF
		END DO
	END DO			

	K12=2+K1+K2
	
	IF(K.NE.K12)  THEN
		IF((K1.EQ.2.AND.K2.EQ.2).OR.(K1.EQ.1.AND.K2.EQ.2)) THEN
			DO I=1,npr
				XP(I,K)=XP(I,K12)
			END DO
		END IF
	END IF

!D_p0
	DO I=1,npr
		DO J=1,P
			PDIST1(I,J)=DSQRT((ZP1(I)-ALLDATA(J,2))**2+(ZP2(I)-ALLDATA(J,3))**2)
		END DO
	END DO

	END SUBROUTINE prepred1